Attribute VB_Name = "modWinAPI"
Option Explicit

Public Declare Function GetTickCount Lib "kernel32.dll" () As Long

Public Const WM_USER As Long = &H400&

Public Const CB_FINDSTRING As Long = &H14C&
Public Const CB_SHOWDROPDOWN As Long = &H14F&
Public Const LB_FINDSTRING As Long = &H18F&
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long

Private Const FORMAT_MESSAGE_ALLOCATE_BUFFER As Long = &H100
Private Const FORMAT_MESSAGE_FROM_SYSTEM As Long = &H1000
Private Declare Function ErrorFormatMessage Lib "kernel32" Alias "FormatMessageW" (ByVal dwFlags As Long, ByRef lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, lpBuffer As Any, ByVal nSize As Long, ByRef Arguments As Long) As Long

Private Declare Function WritePrivateProfileString Lib "kernel32.dll" Alias "WritePrivateProfileStringA" (ByVal Section As String, ByVal Key As String, ByVal Value As String, ByVal File As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32.dll" Alias "GetPrivateProfileStringA" (ByVal Section As String, ByVal Key As String, ByVal Default As String, ByVal Value As String, ByVal Length As Long, ByVal File As String) As Long

Private Declare Function CharToOem Lib "user32" Alias "CharToOemA" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long
Private Declare Function OemToChar Lib "user32" Alias "OemToCharA" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long

Private Enum CommonDialogFlags
  cdofNull = 0&
  cdofReadOnly = &H1&
  cdofOverwritePrompt = &H2&
  cdofHideReadOnly = &H4&
  cdofNoChangeDir = &H8&
  cdofShowHelp = &H10&
  cdofEnableHook = &H20&
  cdofEnableTemplate = &H40&
  cdofEnableTemplateHandle = &H80&
  cdofNoValidate = &H100&
  cdofAllowMultiSelect = &H200&
  cdofExtensionDifferent = &H400&
  cdofPathMustExist = &H800&
  cdofFileMustExist = &H1000&
  cdofCreatePrompt = &H2000&
  cdofShareAware = &H4000&
  cdofNoReadOnlyReturn = &H8000&
  cdofNoTestFileCreate = &H10000
  cdofNoNetworkButton = &H20000
  cdofNoLongNames = &H40000
  cdofExplorer = &H80000
  cdofNodeReferenceLinks = &H100000
  cdofLongNames = &H200000
  cdofEnableIncludeNotify = &H400000
  cdofEnableSizing = &H800000
  cdfNull = 0&
  cdfInitToLogFontStruct = &H40&
  cdfForceFontExist = &H10000
  cdfAnsiOnly = &H400&
  cdfFixedPitchOnly = &H4000&
  cdfScriptsOnly = cdfAnsiOnly
  cdfNoVectorFonts = &H800&
  cdfScalableOnly = &H20000
  cdfTTOnly = &H40000
  cdfNoVertFonts = &H1000000
  cdfWYSIWIG = &H8000
  cdfScreenFonts = &H1
  cdfPrinterFonts = &H2
  cdfBoth = (cdfScreenFonts Or cdfPrinterFonts)
  cdfNoOEMFonts = cdfNoVectorFonts
  cdfLimitSize = &H2000&
  cdfMax = 17
  cdfNoFaceSel = &H80000
  cdfNoScriptSel = &H800000
  cdfNoStyleSel = &H100000
  cdfNoSizeSel = &H200000
  cdfNoSimulations = &H1000&
  cdfAccept = &H0&
  cdfApply = &H200&
  cdfConvertOnly = &H100&
  cdfDefer = &H2
  cdfDisableActivareAs = &H40&
  cdfDisableDisplayAsIcon = &H20&
  cdfDSPBitmap = &H82
  cdfDSPEnhMetaFile = &H8E
  cdfDSPMetaFilePict = &H83
  cdfDSPText = &H81
  cdfEffects = &H100&
  cdfEnableHook = &H8&
  cdfEnableTemplate = &H10&
  cdfEnableTemplateHandle = &H20&
  cdfGDIObjFirst = &H300
  cdfGDIObjLast = &H3FF
  cdfHideChangeIcon = &H80&
  cdfOwnerDisplay = &H80
  cdfPrivateFirst = &H200
  cdfPrivateLast = &H2FF
  cdfReject = &H1
  cdfSelectActivateAs = &H10&
  cdfSelectConvertTo = &H8&
  cdfSelectScript = &H400000
  cdfSetActivateDefault = &H4&
  cdfSetConvertDefault = &H2&
  cdfShowHelp = &H4&
  cdfShowHelpButton = &H1&
  cdfUseStyle = &H80&
  cdfText = 1
  cdfBitmap = 2
  cdfMetaFilePict = 3
  cdfSYLK = 4
  cdfDIF = 5
  cdfTIFF = 6
  cdfOEMText = 7
  cdfDIB = 8
  cdfPalette = 9
  cdfPenData = 10
  cdfRIFF = 11
  cdfWave = 12
  cdfUnicodeText = 13
  cdfEnhMetaFile = 14
  cdfHDrop = 15
  cdfLocale = 16
  cdfDIBV5 = 17
  cdfJPEG = 19
  cdfTopDown_DIB = 20
  cdfMilti_TIFF = 22
  cdfBottomUp_DIB = cdfDIB
End Enum
Private Type OpenFileName
  lStructSize As Long
  hWndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  Flags As CommonDialogFlags
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type
Private Declare Function apiGetOpenFileName Lib "comdlg32" Alias "GetOpenFileNameA" (pOpenFileName As OpenFileName) As Long
Private Declare Function apiGetSaveFileName Lib "comdlg32" Alias "GetSaveFileNameA" (pOpenFileName As OpenFileName) As Long

Private Enum BrowseFlagsEnum
  bifBrowseForComputer = &H1000&
  bifBrowseForPrinter = &H2000&
  bifBrowseIncludeFiles = &H4000&
  bifBrowseIncludeURLs = &H80&
  bifShareable = &H8000&
  bifDontGoBelowDomain = &H2&
  bifEditBox = &H10&
  bifReturnFSAncestors = &H8&
  bifReturnOnlyFSDirs = &H1&
  bifStatusText = &H4&
  bifUseNewUI = &H40&
  bifValidate = &H20&
End Enum
Private Enum BrowseMessages
  'Messages from browser
  bffmInitialized = 1
  bffmSelChanged = 2
  bffmValidateFailedA = 3 'lParam:szPath ret:1(cont),0(EndDialog)
  bffmValidateFailedW = 4 'lParam:szPath ret:1(cont),0(EndDialog)
  'Messages to browser
  bffmSetStatusTextA = (WM_USER + 100)
  bffmEnableOk = (WM_USER + 101)
  bffmSetSelectionA = (WM_USER + 102)
  bffmSetSelectionW = (WM_USER + 103)
  bffmSetStatusTextW = (WM_USER + 104)
#If Win32 Then
  bffmSetStatusText = bffmSetStatusTextW
  bffmSetSelection = bffmSetSelectionW
  bffmValidateFailed = bffmValidateFailedW
#Else
  bffmSetStatusText = bffmSetStatusTextA
  bffmSetSelection = bffmSetSelectionA
  bffmValidateFailed = bffmValidateFailedA
#End If
End Enum
Private Type BrowseInfo
  hWndOwner As Long
  pIDLRoot As Long
  pszDisplayName As Long
  lpszTitle As Long
  ulFlags As BrowseFlagsEnum
  lpfnCallback As Long
  lParam As Long
  iImage As Long
End Type
Private BrowsePath As String
Private Declare Function SHBrowseForFolder Lib "shell32" (lpBI As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)

Private Declare Function PathSearchAndQualifyW Lib "shlwapi" (ByRef pcszPath As Any, ByRef pszFullyQualifiedPath As Any, ByVal cchFullyQualifiedPath As Long) As Long

Private Enum HelpCommands
  HELP_CONTEXT = &H1&        'Display topic in ulTopic
  HELP_QUIT = &H2&           'Terminate help
  HELP_INDEX = &H3&          'Display index
  HELP_CONTENTS = &H3&
  HELP_HELPONHELP = &H4&     'Display help on using help
  HELP_SETINDEX = &H5&       'Set current Index for multi index help
  HELP_SETCONTENTS = &H5&
  HELP_CONTEXTPOPUP = &H8&
  HELP_FORCEFILE = &H9&
  HELP_FINDER = &HB&
  HELP_KEY = &H101&          'Display topic for keyword in offabData
  HELP_COMMAND = &H102&
  HELP_PARTIALKEY = &H105&
  HELP_MULTIKEY = &H201&
  HELP_SETWINPOS = &H203&
End Enum
Private Declare Function WinHelp Lib "user32" Alias "WinHelpW" (ByVal hWndCaller As Long, ByVal lpHelpFile As Long, ByVal uCommand As HelpCommands, ByVal dwData As Long) As Long
Public Enum HelpArticles
  HelpInfoOverview = 1
End Enum

Private Function FnPtr(Ptr As Long) As Long
FnPtr = Ptr
End Function

Public Function BrowseFolder(OwnerForm As Object, ByRef Path As String, Optional ByVal Title As String, Optional ByVal AllowExtStyle As Boolean = False, Optional ByVal AllowManualEnter As Boolean = False) As Boolean
Dim BI As BrowseInfo, lpIDList As Long
Const MaxPath As Long = 1024&
BrowsePath = Path
Title = StrConv(Title, vbFromUnicode)
With BI
  If OwnerForm Is Nothing Then
    .hWndOwner = 0&
  Else
    .hWndOwner = OwnerForm.hWnd
  End If
  .pIDLRoot = 0&
  .pszDisplayName = 0&
  .lpszTitle = StrPtr(Title)
  .ulFlags = bifReturnOnlyFSDirs Or IIf(AllowExtStyle, bifUseNewUI, 0&) Or IIf(AllowManualEnter, bifEditBox, 0&)
  .lpfnCallback = FnPtr(AddressOf BrowseCallbackProc)
  .lParam = 0&
  .iImage = 0&
End With
lpIDList = SHBrowseForFolder(BI)
If lpIDList <> 0 Then
  Path = String$(MaxPath, 0)
  SHGetPathFromIDList lpIDList, Path
  CoTaskMemFree lpIDList
  If InStr(Path, vbNullChar) > 0 Then Path = Left$(Path, InStr(Path, vbNullChar) - 1)
  BrowseFolder = True
End If
End Function

Private Function BrowseCallbackProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal lParam As Long, ByVal lpData As Long) As Long
Select Case uMsg
  Case BrowseMessages.bffmInitialized
    SendMessage hWnd, BrowseMessages.bffmSetSelectionA, True, ByVal BrowsePath
End Select
BrowseCallbackProc = 0&
End Function

Public Function QualifyPath(ByVal Path As String) As String
Dim ret As Long, S As String, N As Long
N = 1024
S = String$(N, 0)
ret = PathSearchAndQualifyW(ByVal StrPtr(Path), ByVal StrPtr(S), N)
If ret <> 0& Then
  If InStr(S, vbNullChar) > 0 Then S = Left$(S, InStr(S, vbNullChar) - 1)
  QualifyPath = S
End If
End Function

Public Function OpenFile(OwnerForm As Object, ByRef FileName As String, Optional ByRef FullFileName As String, Optional ByVal DefaultExt As String, Optional ByVal Filter As String = "All files (*.*)|*.*", Optional ByVal FilterIndex As Long = 1, Optional ByVal InitDir As String, Optional ByVal Title As String) As Boolean
Dim OFN As OpenFileName
Const FileBuff As Long = 255&
If Len(InitDir) = 0 Then InitDir = CurDir$()
If Len(Title) = 0 Then Title = "Open file..."
Filter = Replace(Filter, "|", vbNullChar) & vbNullChar & vbNullChar
OFN.lStructSize = Len(OFN)
With OFN
  If OwnerForm Is Nothing Then
    .hWndOwner = 0&
  Else
    .hWndOwner = OwnerForm.hWnd
  End If
  .hInstance = App.hInstance
  .lpstrTitle = Title
  .lpstrFile = FileName & String$(FileBuff - 1 - Len(FileName), vbNullChar)
  .nMaxFile = FileBuff
  .lpstrFileTitle = String$(FileBuff - 1, vbNullChar)
  .nMaxFileTitle = FileBuff
  .lpstrInitialDir = InitDir
  .lpstrDefExt = DefaultExt
  .lpstrFilter = Filter
  .nFilterIndex = FilterIndex
  .Flags = cdofPathMustExist Or cdofFileMustExist Or cdofHideReadOnly
End With
If apiGetOpenFileName(OFN) <> 0 Then
  If InStr(OFN.lpstrFile, vbNullChar) = 0 Then
    FullFileName = OFN.lpstrFile
  Else
    FullFileName = Left$(OFN.lpstrFile, InStr(OFN.lpstrFile, vbNullChar) - 1)
  End If
  FileName = Mid$(FullFileName, OFN.nFileOffset + 1)
  OpenFile = True
End If
End Function

Public Function SaveFile(OwnerForm As Object, ByRef FileName As String, Optional ByRef FullFileName As String, Optional ByVal DefaultExt As String, Optional ByVal Filter As String = "All files (*.*)|*.*", Optional ByVal FilterIndex As Long = 1, Optional ByVal InitDir As String, Optional ByVal Title As String) As Boolean
Dim OFN As OpenFileName
Const FileBuff As Long = 255&
If Len(InitDir) = 0 Then InitDir = CurDir$()
If Len(Title) = 0 Then Title = "Save file..."
Filter = Replace(Filter, "|", vbNullChar) & vbNullChar & vbNullChar
OFN.lStructSize = Len(OFN)
With OFN
  If OwnerForm Is Nothing Then
    .hWndOwner = 0&
  Else
    .hWndOwner = OwnerForm.hWnd
  End If
  .hInstance = App.hInstance
  .lpstrTitle = Title
  .lpstrFile = FileName & String$(FileBuff - 1 - Len(FileName), vbNullChar)
  .nMaxFile = FileBuff
  .lpstrFileTitle = String$(FileBuff - 1, vbNullChar)
  .nMaxFileTitle = FileBuff
  .lpstrInitialDir = InitDir
  .lpstrDefExt = DefaultExt
  .lpstrFilter = Filter
  .nFilterIndex = FilterIndex
  .Flags = cdofPathMustExist Or cdofOverwritePrompt Or cdofHideReadOnly
End With
If apiGetSaveFileName(OFN) <> 0 Then
  If InStr(OFN.lpstrFile, vbNullChar) = 0 Then
    FullFileName = OFN.lpstrFile
  Else
    FullFileName = Left$(OFN.lpstrFile, InStr(OFN.lpstrFile, vbNullChar) - 1)
  End If
  FileName = Mid$(FullFileName, OFN.nFileOffset + 1)
  SaveFile = True
End If
End Function

Public Sub ShowHelp(ParentForm As Form, Optional ByVal ContextID As HelpArticles, Optional ByVal Popup As Boolean = False)
Dim hWnd As Long, File As String, ret As Long
If Not (ParentForm Is Nothing) Then hWnd = ParentForm.hWnd
File = App.HelpFile & vbNullChar
If ContextID < 0& Then
  Call WinHelp(hWnd, ByVal StrPtr(File), HELP_QUIT, 0&)
  Exit Sub
End If
If ContextID = 0& Then
  ret = WinHelp(hWnd, ByVal StrPtr(File), HELP_INDEX, 0&)
Else
  If Popup Then
    ret = WinHelp(hWnd, ByVal StrPtr(File), HELP_CONTEXTPOPUP, ContextID)
  Else
    ret = WinHelp(hWnd, ByVal StrPtr(File), HELP_CONTEXT, ContextID)
  End If
End If
End Sub

Public Sub ShowHelpTopic(ParentForm As Form, Optional ByVal Topic As String)
Dim hWnd As Long, File As String, ret As Long
If Not (ParentForm Is Nothing) Then hWnd = ParentForm.hWnd
File = App.HelpFile & vbNullChar
If Len(Topic) = 0& Then
  ret = WinHelp(hWnd, ByVal StrPtr(File), HELP_CONTENTS, 0&)
Else
  Topic = "JumpID(""" & App.HelpFile & """,""" & Topic & """)" & vbNullChar
  ret = WinHelp(hWnd, ByVal StrPtr(File), HELP_COMMAND, ByVal StrPtr(Topic))
End If
End Sub

Public Sub SelAllText(Control As Control)
Control.SelStart = 0
Control.SelLength = Len(Control.Text)
End Sub

Public Function ListSelectedID(ListControl As Control, Optional ByVal ListIndex As Long = -1) As Long
If TypeOf ListControl Is ComboBox Then
ElseIf TypeOf ListControl Is ListBox Then
Else
  Exit Function
End If
If ListIndex < 0 Then ListIndex = ListControl.ListIndex
If ListIndex < 0 Then
  ListSelectedID = 0&
Else
  ListSelectedID = ListControl.ItemData(ListIndex)
End If
End Function

Public Function FindByID(ListControl As Control, ByVal Value As Long) As Long
Dim I As Long
If TypeOf ListControl Is ComboBox Then
ElseIf TypeOf ListControl Is ListBox Then
Else
  Exit Function
End If
For I = ListControl.ListCount - 1 To 0 Step -1
  If ListControl.ItemData(I) = Value Then Exit For
Next I
FindByID = I
End Function

Public Function FindByValue(ListControl As Control, Optional ByVal Value As String) As Long
Dim I As Long, msg As Long
If TypeOf ListControl Is ComboBox Then
  msg = CB_FINDSTRING
  If Len(Value) = 0 Then Value = ListControl.Text
ElseIf TypeOf ListControl Is ListBox Then
  msg = LB_FINDSTRING
Else
  Exit Function
End If
I = SendMessage(ListControl.hWnd, msg, -1&, ByVal Value)
FindByValue = I
End Function

Public Function FormatErrorMessage(ByVal ErrNumber As Long, ByVal ErrDLLError As Long, Optional ByVal ErrDescription As String, Optional ByVal ErrSource As String, Optional ByVal ErrStage As String, Optional ByVal ErrInfo As String) As String
Const MaxLen As Long = 1024&
Dim msg, ret As Long
If ErrNumber = 0& And ErrDLLError = 0& Then
  msg = " ." & vbNewLine
ElseIf ErrNumber <> 0& And ErrDLLError = 0& Then
  msg = " " & ErrNumber & " ( 0x" & Right$("00000000" & Hex$(ErrNumber), 8) & " )" & vbNewLine
ElseIf ErrNumber = 0& And ErrDLLError <> 0& Then
  msg = String$(MaxLen, vbNullChar)
  ret = ErrorFormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, ErrDLLError, ByVal 0&, ByVal StrPtr(msg), MaxLen, ByVal 0&)
  msg = "  " & ErrDLLError & " ( 0x" & Right$("00000000" & Hex$(ErrDLLError), 8) & " )" & vbNewLine & Left$(msg, ret)
Else
  msg = String$(MaxLen, vbNullChar)
  ret = ErrorFormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, ErrDLLError, ByVal 0&, ByVal StrPtr(msg), MaxLen, ByVal 0&)
  msg = " " & ErrNumber & " ( 0x" & Right$("00000000" & Hex$(ErrNumber), 8) & ", 0x" & Right$("00000000" & Hex$(ErrDLLError), 8) & " ) - " & Left$(msg, ret)
End If
If Len(ErrDescription) > 0 Then msg = msg & ErrDescription & vbNewLine
If Len(ErrSource) > 0 Then msg = msg & ": " & ErrSource & vbNewLine
If Len(ErrStage) > 0 Then msg = msg & ": " & ErrStage & vbNewLine
If Len(ErrInfo) > 0 Then msg = msg & vbNewLine & " : " & vbNewLine & ErrInfo & vbNewLine
FormatErrorMessage = msg
End Function
